/* Settings.c generated by valac 0.56.17, the Vala compiler
 * generated from Settings.vala, do not modify */

/* Settings.vala
 *
 * The following code is a derivative work of the code from
 * https://github.com/elementary/granite/blob/master/lib/Services/Settings.vala
 * which is licensed under GNU Lesser General Public version 3 of the License,
 * or (at your option) any later version.
 *
 * Copyright 2020 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include "marble.h"
#include <gio/gio.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	MARBLE_SETTINGS_0_PROPERTY,
	MARBLE_SETTINGS_SCHEMA_PROPERTY,
	MARBLE_SETTINGS_NUM_PROPERTIES
};
static GParamSpec* marble_settings_properties[MARBLE_SETTINGS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_param_spec_unref0(var) ((var == NULL) ? NULL : (var = (g_param_spec_unref (var), NULL)))
#define _g_type_class_unref0(var) ((var == NULL) ? NULL : (var = (g_type_class_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _MarbleSettingsPrivate {
	GSettings* _schema;
	gboolean updating;
	gboolean doing_setup;
};

static gint MarbleSettings_private_offset;
static gpointer marble_settings_parent_class = NULL;

static void marble_settings_load_key (MarbleSettings* self,
                               const gchar* key);
static void marble_settings_on_notify (MarbleSettings* self,
                                GObject* sender,
                                GParamSpec* prop);
static void _marble_settings_on_notify_g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self);
static void marble_settings_save_key (MarbleSettings* self,
                               const gchar* key);
static GObject * marble_settings_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _marble_settings_load_key_g_settings_changed (GSettings* _sender,
                                                   const gchar* key,
                                                   gpointer self);
static void marble_settings_finalize (GObject * obj);
static GType marble_settings_get_type_once (void);
static void _vala_marble_settings_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_marble_settings_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
marble_settings_get_instance_private (MarbleSettings* self)
{
	return G_STRUCT_MEMBER_P (self, MarbleSettings_private_offset);
}

MarbleSettings*
marble_settings_construct (GType object_type,
                           const gchar* path)
{
	MarbleSettings * self = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 33 "../src/services/Settings.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 35 "../src/services/Settings.vala"
	_tmp0_ = g_settings_new (path);
#line 35 "../src/services/Settings.vala"
	_tmp1_ = _tmp0_;
#line 35 "../src/services/Settings.vala"
	self = (MarbleSettings*) g_object_new (object_type, "schema", _tmp1_, NULL);
#line 35 "../src/services/Settings.vala"
	_g_object_unref0 (_tmp1_);
#line 33 "../src/services/Settings.vala"
	return self;
#line 128 "Settings.c"
}

static gpointer
_g_param_spec_ref0 (gpointer self)
{
#line 58 "../src/services/Settings.vala"
	return self ? g_param_spec_ref (self) : NULL;
#line 136 "Settings.c"
}

static void
_marble_settings_on_notify_g_object_notify (GObject* _sender,
                                            GParamSpec* pspec,
                                            gpointer self)
{
#line 63 "../src/services/Settings.vala"
	marble_settings_on_notify ((MarbleSettings*) self, _sender, pspec);
#line 146 "Settings.c"
}

static void
marble_settings_load_key (MarbleSettings* self,
                          const gchar* key)
{
	GObjectClass* obj_class = NULL;
	GTypeClass* _tmp0_;
	GParamSpec* prop = NULL;
	GObjectClass* _tmp1_;
	GParamSpec* _tmp2_;
	GParamSpec* _tmp3_;
	GParamSpec* _tmp4_;
	guint _tmp5_;
	GType type = 0UL;
	GParamSpec* _tmp6_;
	GValue val = {0};
	GValue _tmp7_ = {0};
	GParamSpec* _tmp8_;
#line 52 "../src/services/Settings.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/services/Settings.vala"
	g_return_if_fail (key != NULL);
#line 54 "../src/services/Settings.vala"
	if (g_strcmp0 (key, "schema") == 0) {
#line 55 "../src/services/Settings.vala"
		return;
#line 174 "Settings.c"
	}
#line 57 "../src/services/Settings.vala"
	_tmp0_ = g_type_class_ref (G_TYPE_FROM_INSTANCE ((GObject*) self));
#line 57 "../src/services/Settings.vala"
	obj_class = (GObjectClass*) _tmp0_;
#line 58 "../src/services/Settings.vala"
	_tmp1_ = obj_class;
#line 58 "../src/services/Settings.vala"
	_tmp2_ = g_object_class_find_property (_tmp1_, key);
#line 58 "../src/services/Settings.vala"
	_tmp3_ = _g_param_spec_ref0 (_tmp2_);
#line 58 "../src/services/Settings.vala"
	prop = _tmp3_;
#line 60 "../src/services/Settings.vala"
	_tmp4_ = prop;
#line 60 "../src/services/Settings.vala"
	if (_tmp4_ == NULL) {
#line 61 "../src/services/Settings.vala"
		_g_param_spec_unref0 (prop);
#line 61 "../src/services/Settings.vala"
		_g_type_class_unref0 (obj_class);
#line 61 "../src/services/Settings.vala"
		return;
#line 198 "Settings.c"
	}
#line 63 "../src/services/Settings.vala"
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp5_, NULL, FALSE);
#line 63 "../src/services/Settings.vala"
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _marble_settings_on_notify_g_object_notify, self);
#line 65 "../src/services/Settings.vala"
	_tmp6_ = prop;
#line 65 "../src/services/Settings.vala"
	type = _tmp6_->value_type;
#line 66 "../src/services/Settings.vala"
	g_value_init (&_tmp7_, type);
#line 66 "../src/services/Settings.vala"
	val = _tmp7_;
#line 67 "../src/services/Settings.vala"
	g_object_get_property ((GObject*) self, key, &val);
#line 69 "../src/services/Settings.vala"
	_tmp8_ = prop;
#line 69 "../src/services/Settings.vala"
	if (G_VALUE_TYPE (&val) == _tmp8_->value_type) {
#line 71 "../src/services/Settings.vala"
		if (type == G_TYPE_INT) {
#line 220 "Settings.c"
			GParamSpec* _tmp9_;
			const gchar* _tmp10_;
			GSettings* _tmp11_;
			GValue _tmp12_ = {0};
#line 72 "../src/services/Settings.vala"
			_tmp9_ = prop;
#line 72 "../src/services/Settings.vala"
			_tmp10_ = _tmp9_->name;
#line 72 "../src/services/Settings.vala"
			_tmp11_ = self->priv->_schema;
#line 72 "../src/services/Settings.vala"
			g_value_init (&_tmp12_, G_TYPE_INT);
#line 72 "../src/services/Settings.vala"
			g_value_set_int (&_tmp12_, g_settings_get_int (_tmp11_, key));
#line 72 "../src/services/Settings.vala"
			g_object_set_property ((GObject*) self, _tmp10_, &_tmp12_);
#line 72 "../src/services/Settings.vala"
			G_IS_VALUE (&_tmp12_) ? (g_value_unset (&_tmp12_), NULL) : NULL;
#line 239 "Settings.c"
		} else {
#line 73 "../src/services/Settings.vala"
			if (type == G_TYPE_UINT) {
#line 243 "Settings.c"
				GParamSpec* _tmp13_;
				const gchar* _tmp14_;
				GSettings* _tmp15_;
				GValue _tmp16_ = {0};
#line 74 "../src/services/Settings.vala"
				_tmp13_ = prop;
#line 74 "../src/services/Settings.vala"
				_tmp14_ = _tmp13_->name;
#line 74 "../src/services/Settings.vala"
				_tmp15_ = self->priv->_schema;
#line 74 "../src/services/Settings.vala"
				g_value_init (&_tmp16_, G_TYPE_UINT);
#line 74 "../src/services/Settings.vala"
				g_value_set_uint (&_tmp16_, g_settings_get_uint (_tmp15_, key));
#line 74 "../src/services/Settings.vala"
				g_object_set_property ((GObject*) self, _tmp14_, &_tmp16_);
#line 74 "../src/services/Settings.vala"
				G_IS_VALUE (&_tmp16_) ? (g_value_unset (&_tmp16_), NULL) : NULL;
#line 262 "Settings.c"
			} else {
#line 75 "../src/services/Settings.vala"
				if (type == G_TYPE_DOUBLE) {
#line 266 "Settings.c"
					GParamSpec* _tmp17_;
					const gchar* _tmp18_;
					GSettings* _tmp19_;
					GValue _tmp20_ = {0};
#line 76 "../src/services/Settings.vala"
					_tmp17_ = prop;
#line 76 "../src/services/Settings.vala"
					_tmp18_ = _tmp17_->name;
#line 76 "../src/services/Settings.vala"
					_tmp19_ = self->priv->_schema;
#line 76 "../src/services/Settings.vala"
					g_value_init (&_tmp20_, G_TYPE_DOUBLE);
#line 76 "../src/services/Settings.vala"
					g_value_set_double (&_tmp20_, g_settings_get_double (_tmp19_, key));
#line 76 "../src/services/Settings.vala"
					g_object_set_property ((GObject*) self, _tmp18_, &_tmp20_);
#line 76 "../src/services/Settings.vala"
					G_IS_VALUE (&_tmp20_) ? (g_value_unset (&_tmp20_), NULL) : NULL;
#line 285 "Settings.c"
				} else {
#line 77 "../src/services/Settings.vala"
					if (type == G_TYPE_BOOLEAN) {
#line 289 "Settings.c"
						GParamSpec* _tmp21_;
						const gchar* _tmp22_;
						GSettings* _tmp23_;
						GValue _tmp24_ = {0};
#line 78 "../src/services/Settings.vala"
						_tmp21_ = prop;
#line 78 "../src/services/Settings.vala"
						_tmp22_ = _tmp21_->name;
#line 78 "../src/services/Settings.vala"
						_tmp23_ = self->priv->_schema;
#line 78 "../src/services/Settings.vala"
						g_value_init (&_tmp24_, G_TYPE_BOOLEAN);
#line 78 "../src/services/Settings.vala"
						g_value_set_boolean (&_tmp24_, g_settings_get_boolean (_tmp23_, key));
#line 78 "../src/services/Settings.vala"
						g_object_set_property ((GObject*) self, _tmp22_, &_tmp24_);
#line 78 "../src/services/Settings.vala"
						G_IS_VALUE (&_tmp24_) ? (g_value_unset (&_tmp24_), NULL) : NULL;
#line 308 "Settings.c"
					} else {
#line 79 "../src/services/Settings.vala"
						if (type == G_TYPE_STRING) {
#line 312 "Settings.c"
							GParamSpec* _tmp25_;
							const gchar* _tmp26_;
							GSettings* _tmp27_;
							gchar* _tmp28_;
							GValue _tmp29_ = {0};
#line 80 "../src/services/Settings.vala"
							_tmp25_ = prop;
#line 80 "../src/services/Settings.vala"
							_tmp26_ = _tmp25_->name;
#line 80 "../src/services/Settings.vala"
							_tmp27_ = self->priv->_schema;
#line 80 "../src/services/Settings.vala"
							_tmp28_ = g_settings_get_string (_tmp27_, key);
#line 80 "../src/services/Settings.vala"
							g_value_init (&_tmp29_, G_TYPE_STRING);
#line 80 "../src/services/Settings.vala"
							g_value_take_string (&_tmp29_, _tmp28_);
#line 80 "../src/services/Settings.vala"
							g_object_set_property ((GObject*) self, _tmp26_, &_tmp29_);
#line 80 "../src/services/Settings.vala"
							G_IS_VALUE (&_tmp29_) ? (g_value_unset (&_tmp29_), NULL) : NULL;
#line 334 "Settings.c"
						} else {
#line 81 "../src/services/Settings.vala"
							if (type == G_TYPE_STRV) {
#line 338 "Settings.c"
								GParamSpec* _tmp30_;
								const gchar* _tmp31_;
								GSettings* _tmp32_;
								gchar** _tmp33_;
								gchar** _tmp34_;
								GValue _tmp35_ = {0};
#line 82 "../src/services/Settings.vala"
								_tmp30_ = prop;
#line 82 "../src/services/Settings.vala"
								_tmp31_ = _tmp30_->name;
#line 82 "../src/services/Settings.vala"
								_tmp32_ = self->priv->_schema;
#line 82 "../src/services/Settings.vala"
								_tmp34_ = _tmp33_ = g_settings_get_strv (_tmp32_, key);
#line 82 "../src/services/Settings.vala"
								g_value_init (&_tmp35_, G_TYPE_STRV);
#line 82 "../src/services/Settings.vala"
								g_value_take_boxed (&_tmp35_, _tmp34_);
#line 82 "../src/services/Settings.vala"
								g_object_set_property ((GObject*) self, _tmp31_, &_tmp35_);
#line 82 "../src/services/Settings.vala"
								G_IS_VALUE (&_tmp35_) ? (g_value_unset (&_tmp35_), NULL) : NULL;
#line 361 "Settings.c"
							} else {
#line 83 "../src/services/Settings.vala"
								if (type == G_TYPE_INT64) {
#line 365 "Settings.c"
									GParamSpec* _tmp36_;
									const gchar* _tmp37_;
									GSettings* _tmp38_;
									GVariant* _tmp39_;
									GVariant* _tmp40_;
									GValue _tmp41_ = {0};
#line 84 "../src/services/Settings.vala"
									_tmp36_ = prop;
#line 84 "../src/services/Settings.vala"
									_tmp37_ = _tmp36_->name;
#line 84 "../src/services/Settings.vala"
									_tmp38_ = self->priv->_schema;
#line 84 "../src/services/Settings.vala"
									_tmp39_ = g_settings_get_value (_tmp38_, key);
#line 84 "../src/services/Settings.vala"
									_tmp40_ = _tmp39_;
#line 84 "../src/services/Settings.vala"
									g_value_init (&_tmp41_, G_TYPE_INT64);
#line 84 "../src/services/Settings.vala"
									g_value_set_int64 (&_tmp41_, g_variant_get_int64 (_tmp40_));
#line 84 "../src/services/Settings.vala"
									g_object_set_property ((GObject*) self, _tmp37_, &_tmp41_);
#line 84 "../src/services/Settings.vala"
									G_IS_VALUE (&_tmp41_) ? (g_value_unset (&_tmp41_), NULL) : NULL;
#line 84 "../src/services/Settings.vala"
									_g_variant_unref0 (_tmp40_);
#line 392 "Settings.c"
								} else {
#line 85 "../src/services/Settings.vala"
									if (type == G_TYPE_UINT64) {
#line 396 "Settings.c"
										GParamSpec* _tmp42_;
										const gchar* _tmp43_;
										GSettings* _tmp44_;
										GVariant* _tmp45_;
										GVariant* _tmp46_;
										GValue _tmp47_ = {0};
#line 86 "../src/services/Settings.vala"
										_tmp42_ = prop;
#line 86 "../src/services/Settings.vala"
										_tmp43_ = _tmp42_->name;
#line 86 "../src/services/Settings.vala"
										_tmp44_ = self->priv->_schema;
#line 86 "../src/services/Settings.vala"
										_tmp45_ = g_settings_get_value (_tmp44_, key);
#line 86 "../src/services/Settings.vala"
										_tmp46_ = _tmp45_;
#line 86 "../src/services/Settings.vala"
										g_value_init (&_tmp47_, G_TYPE_UINT64);
#line 86 "../src/services/Settings.vala"
										g_value_set_uint64 (&_tmp47_, g_variant_get_uint64 (_tmp46_));
#line 86 "../src/services/Settings.vala"
										g_object_set_property ((GObject*) self, _tmp43_, &_tmp47_);
#line 86 "../src/services/Settings.vala"
										G_IS_VALUE (&_tmp47_) ? (g_value_unset (&_tmp47_), NULL) : NULL;
#line 86 "../src/services/Settings.vala"
										_g_variant_unref0 (_tmp46_);
#line 423 "Settings.c"
									} else {
#line 88 "../src/services/Settings.vala"
										if (G_TYPE_IS_ENUM (type)) {
#line 427 "Settings.c"
											GParamSpec* _tmp48_;
											const gchar* _tmp49_;
											GSettings* _tmp50_;
											GValue _tmp51_ = {0};
#line 89 "../src/services/Settings.vala"
											_tmp48_ = prop;
#line 89 "../src/services/Settings.vala"
											_tmp49_ = _tmp48_->name;
#line 89 "../src/services/Settings.vala"
											_tmp50_ = self->priv->_schema;
#line 89 "../src/services/Settings.vala"
											g_value_init (&_tmp51_, G_TYPE_INT);
#line 89 "../src/services/Settings.vala"
											g_value_set_int (&_tmp51_, g_settings_get_enum (_tmp50_, key));
#line 89 "../src/services/Settings.vala"
											g_object_set_property ((GObject*) self, _tmp49_, &_tmp51_);
#line 89 "../src/services/Settings.vala"
											G_IS_VALUE (&_tmp51_) ? (g_value_unset (&_tmp51_), NULL) : NULL;
#line 446 "Settings.c"
										}
									}
								}
							}
						}
					}
				}
			}
		}
	} else {
		gchar* _tmp52_;
		gchar* _tmp53_;
#line 93 "../src/services/Settings.vala"
		_tmp52_ = g_strdup_printf ("%lu", (gulong) type);
#line 93 "../src/services/Settings.vala"
		_tmp53_ = _tmp52_;
#line 93 "../src/services/Settings.vala"
		g_warning ("Settings.vala:93: Unsuported type %s for key %s", _tmp53_, key);
#line 93 "../src/services/Settings.vala"
		_g_free0 (_tmp53_);
#line 467 "Settings.c"
	}
#line 96 "../src/services/Settings.vala"
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _marble_settings_on_notify_g_object_notify, self, 0);
#line 52 "../src/services/Settings.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 52 "../src/services/Settings.vala"
	_g_param_spec_unref0 (prop);
#line 52 "../src/services/Settings.vala"
	_g_type_class_unref0 (obj_class);
#line 477 "Settings.c"
}

static void
marble_settings_save_key (MarbleSettings* self,
                          const gchar* key)
{
	gboolean _tmp0_ = FALSE;
	GObjectClass* obj_class = NULL;
	GTypeClass* _tmp1_;
	GParamSpec* prop = NULL;
	GObjectClass* _tmp2_;
	GParamSpec* _tmp3_;
	GParamSpec* _tmp4_;
	GParamSpec* _tmp5_;
	guint _tmp6_;
	gboolean res = FALSE;
	GType type = 0UL;
	GParamSpec* _tmp7_;
	GValue val = {0};
	GValue _tmp8_ = {0};
	GParamSpec* _tmp9_;
	const gchar* _tmp10_;
	GParamSpec* _tmp11_;
#line 99 "../src/services/Settings.vala"
	g_return_if_fail (self != NULL);
#line 99 "../src/services/Settings.vala"
	g_return_if_fail (key != NULL);
#line 101 "../src/services/Settings.vala"
	if (g_strcmp0 (key, "schema") == 0) {
#line 101 "../src/services/Settings.vala"
		_tmp0_ = TRUE;
#line 509 "Settings.c"
	} else {
#line 101 "../src/services/Settings.vala"
		_tmp0_ = self->priv->updating;
#line 513 "Settings.c"
	}
#line 101 "../src/services/Settings.vala"
	if (_tmp0_) {
#line 102 "../src/services/Settings.vala"
		return;
#line 519 "Settings.c"
	}
#line 104 "../src/services/Settings.vala"
	_tmp1_ = g_type_class_ref (G_TYPE_FROM_INSTANCE ((GObject*) self));
#line 104 "../src/services/Settings.vala"
	obj_class = (GObjectClass*) _tmp1_;
#line 105 "../src/services/Settings.vala"
	_tmp2_ = obj_class;
#line 105 "../src/services/Settings.vala"
	_tmp3_ = g_object_class_find_property (_tmp2_, key);
#line 105 "../src/services/Settings.vala"
	_tmp4_ = _g_param_spec_ref0 (_tmp3_);
#line 105 "../src/services/Settings.vala"
	prop = _tmp4_;
#line 107 "../src/services/Settings.vala"
	_tmp5_ = prop;
#line 107 "../src/services/Settings.vala"
	if (_tmp5_ == NULL) {
#line 108 "../src/services/Settings.vala"
		_g_param_spec_unref0 (prop);
#line 108 "../src/services/Settings.vala"
		_g_type_class_unref0 (obj_class);
#line 108 "../src/services/Settings.vala"
		return;
#line 543 "Settings.c"
	}
#line 110 "../src/services/Settings.vala"
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp6_, NULL, FALSE);
#line 110 "../src/services/Settings.vala"
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _marble_settings_on_notify_g_object_notify, self);
#line 112 "../src/services/Settings.vala"
	res = TRUE;
#line 113 "../src/services/Settings.vala"
	self->priv->updating = TRUE;
#line 115 "../src/services/Settings.vala"
	_tmp7_ = prop;
#line 115 "../src/services/Settings.vala"
	type = _tmp7_->value_type;
#line 116 "../src/services/Settings.vala"
	g_value_init (&_tmp8_, type);
#line 116 "../src/services/Settings.vala"
	val = _tmp8_;
#line 117 "../src/services/Settings.vala"
	_tmp9_ = prop;
#line 117 "../src/services/Settings.vala"
	_tmp10_ = _tmp9_->name;
#line 117 "../src/services/Settings.vala"
	g_object_get_property ((GObject*) self, _tmp10_, &val);
#line 119 "../src/services/Settings.vala"
	_tmp11_ = prop;
#line 119 "../src/services/Settings.vala"
	if (G_VALUE_TYPE (&val) == _tmp11_->value_type) {
#line 571 "Settings.c"
		gboolean _tmp12_ = FALSE;
#line 121 "../src/services/Settings.vala"
		if (type == G_TYPE_INT) {
#line 575 "Settings.c"
			GSettings* _tmp13_;
#line 122 "../src/services/Settings.vala"
			_tmp13_ = self->priv->_schema;
#line 122 "../src/services/Settings.vala"
			_tmp12_ = g_value_get_int (&val) != g_settings_get_int (_tmp13_, key);
#line 581 "Settings.c"
		} else {
#line 121 "../src/services/Settings.vala"
			_tmp12_ = FALSE;
#line 585 "Settings.c"
		}
#line 121 "../src/services/Settings.vala"
		if (_tmp12_) {
#line 589 "Settings.c"
			GSettings* _tmp14_;
#line 124 "../src/services/Settings.vala"
			_tmp14_ = self->priv->_schema;
#line 124 "../src/services/Settings.vala"
			res = g_settings_set_int (_tmp14_, key, g_value_get_int (&val));
#line 595 "Settings.c"
		} else {
			gboolean _tmp15_ = FALSE;
#line 126 "../src/services/Settings.vala"
			if (type == G_TYPE_UINT) {
#line 600 "Settings.c"
				GSettings* _tmp16_;
#line 127 "../src/services/Settings.vala"
				_tmp16_ = self->priv->_schema;
#line 127 "../src/services/Settings.vala"
				_tmp15_ = g_value_get_uint (&val) != g_settings_get_uint (_tmp16_, key);
#line 606 "Settings.c"
			} else {
#line 126 "../src/services/Settings.vala"
				_tmp15_ = FALSE;
#line 610 "Settings.c"
			}
#line 126 "../src/services/Settings.vala"
			if (_tmp15_) {
#line 614 "Settings.c"
				GSettings* _tmp17_;
#line 129 "../src/services/Settings.vala"
				_tmp17_ = self->priv->_schema;
#line 129 "../src/services/Settings.vala"
				res = g_settings_set_uint (_tmp17_, key, g_value_get_uint (&val));
#line 620 "Settings.c"
			} else {
				gboolean _tmp18_ = FALSE;
#line 131 "../src/services/Settings.vala"
				if (type == G_TYPE_DOUBLE) {
#line 625 "Settings.c"
					GSettings* _tmp19_;
#line 132 "../src/services/Settings.vala"
					_tmp19_ = self->priv->_schema;
#line 132 "../src/services/Settings.vala"
					_tmp18_ = g_value_get_double (&val) != g_settings_get_double (_tmp19_, key);
#line 631 "Settings.c"
				} else {
#line 131 "../src/services/Settings.vala"
					_tmp18_ = FALSE;
#line 635 "Settings.c"
				}
#line 131 "../src/services/Settings.vala"
				if (_tmp18_) {
#line 639 "Settings.c"
					GSettings* _tmp20_;
#line 134 "../src/services/Settings.vala"
					_tmp20_ = self->priv->_schema;
#line 134 "../src/services/Settings.vala"
					res = g_settings_set_double (_tmp20_, key, g_value_get_double (&val));
#line 645 "Settings.c"
				} else {
					gboolean _tmp21_ = FALSE;
#line 136 "../src/services/Settings.vala"
					if (type == G_TYPE_BOOLEAN) {
#line 650 "Settings.c"
						GSettings* _tmp22_;
#line 137 "../src/services/Settings.vala"
						_tmp22_ = self->priv->_schema;
#line 137 "../src/services/Settings.vala"
						_tmp21_ = g_value_get_boolean (&val) != g_settings_get_boolean (_tmp22_, key);
#line 656 "Settings.c"
					} else {
#line 136 "../src/services/Settings.vala"
						_tmp21_ = FALSE;
#line 660 "Settings.c"
					}
#line 136 "../src/services/Settings.vala"
					if (_tmp21_) {
#line 664 "Settings.c"
						GSettings* _tmp23_;
#line 139 "../src/services/Settings.vala"
						_tmp23_ = self->priv->_schema;
#line 139 "../src/services/Settings.vala"
						res = g_settings_set_boolean (_tmp23_, key, g_value_get_boolean (&val));
#line 670 "Settings.c"
					} else {
						gboolean _tmp24_ = FALSE;
#line 141 "../src/services/Settings.vala"
						if (type == G_TYPE_STRING) {
#line 675 "Settings.c"
							const gchar* _tmp25_;
							GSettings* _tmp26_;
							gchar* _tmp27_;
							gchar* _tmp28_;
#line 142 "../src/services/Settings.vala"
							_tmp25_ = g_value_get_string (&val);
#line 142 "../src/services/Settings.vala"
							_tmp26_ = self->priv->_schema;
#line 142 "../src/services/Settings.vala"
							_tmp27_ = g_settings_get_string (_tmp26_, key);
#line 142 "../src/services/Settings.vala"
							_tmp28_ = _tmp27_;
#line 142 "../src/services/Settings.vala"
							_tmp24_ = g_strcmp0 (_tmp25_, _tmp28_) != 0;
#line 142 "../src/services/Settings.vala"
							_g_free0 (_tmp28_);
#line 692 "Settings.c"
						} else {
#line 141 "../src/services/Settings.vala"
							_tmp24_ = FALSE;
#line 696 "Settings.c"
						}
#line 141 "../src/services/Settings.vala"
						if (_tmp24_) {
#line 700 "Settings.c"
							GSettings* _tmp29_;
							const gchar* _tmp30_;
#line 144 "../src/services/Settings.vala"
							_tmp29_ = self->priv->_schema;
#line 144 "../src/services/Settings.vala"
							_tmp30_ = g_value_get_string (&val);
#line 144 "../src/services/Settings.vala"
							res = g_settings_set_string (_tmp29_, key, _tmp30_);
#line 709 "Settings.c"
						} else {
#line 146 "../src/services/Settings.vala"
							if (type == G_TYPE_STRV) {
#line 713 "Settings.c"
								gchar** strv = NULL;
								gint strv_length1;
								gint _strv_size_;
								gchar** _tmp31_;
								gint _tmp31__length1;
								GSettings* _tmp32_;
								gchar** _tmp33_;
								gchar** _tmp34_;
								gchar** _tmp35_;
								gint _tmp35__length1;
								gboolean _tmp36_;
#line 148 "../src/services/Settings.vala"
								strv = NULL;
#line 148 "../src/services/Settings.vala"
								strv_length1 = 0;
#line 148 "../src/services/Settings.vala"
								_strv_size_ = strv_length1;
#line 149 "../src/services/Settings.vala"
								g_object_get ((GObject*) self, key, &strv, NULL);
#line 150 "../src/services/Settings.vala"
								_tmp31_ = strv;
#line 150 "../src/services/Settings.vala"
								_tmp31__length1 = strv_length1;
#line 150 "../src/services/Settings.vala"
								_tmp32_ = self->priv->_schema;
#line 150 "../src/services/Settings.vala"
								_tmp34_ = _tmp33_ = g_settings_get_strv (_tmp32_, key);
#line 150 "../src/services/Settings.vala"
								_tmp35_ = _tmp34_;
#line 150 "../src/services/Settings.vala"
								_tmp35__length1 = _vala_array_length (_tmp33_);
#line 150 "../src/services/Settings.vala"
								_tmp36_ = _tmp31_ != _tmp35_;
#line 150 "../src/services/Settings.vala"
								_tmp35_ = (_vala_array_free (_tmp35_, _tmp35__length1, (GDestroyNotify) g_free), NULL);
#line 150 "../src/services/Settings.vala"
								if (_tmp36_) {
#line 751 "Settings.c"
									GSettings* _tmp37_;
									gchar** _tmp38_;
									gint _tmp38__length1;
#line 152 "../src/services/Settings.vala"
									_tmp37_ = self->priv->_schema;
#line 152 "../src/services/Settings.vala"
									_tmp38_ = strv;
#line 152 "../src/services/Settings.vala"
									_tmp38__length1 = strv_length1;
#line 152 "../src/services/Settings.vala"
									res = g_settings_set_strv (_tmp37_, key, _tmp38_);
#line 763 "Settings.c"
								}
#line 146 "../src/services/Settings.vala"
								strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
#line 767 "Settings.c"
							} else {
								gboolean _tmp39_ = FALSE;
#line 155 "../src/services/Settings.vala"
								if (type == G_TYPE_INT64) {
#line 772 "Settings.c"
									GSettings* _tmp40_;
									GVariant* _tmp41_;
									GVariant* _tmp42_;
#line 156 "../src/services/Settings.vala"
									_tmp40_ = self->priv->_schema;
#line 156 "../src/services/Settings.vala"
									_tmp41_ = g_settings_get_value (_tmp40_, key);
#line 156 "../src/services/Settings.vala"
									_tmp42_ = _tmp41_;
#line 156 "../src/services/Settings.vala"
									_tmp39_ = g_value_get_int64 (&val) != g_variant_get_int64 (_tmp42_);
#line 156 "../src/services/Settings.vala"
									_g_variant_unref0 (_tmp42_);
#line 786 "Settings.c"
								} else {
#line 155 "../src/services/Settings.vala"
									_tmp39_ = FALSE;
#line 790 "Settings.c"
								}
#line 155 "../src/services/Settings.vala"
								if (_tmp39_) {
#line 794 "Settings.c"
									GSettings* _tmp43_;
									GVariant* _tmp44_;
									GVariant* _tmp45_;
#line 158 "../src/services/Settings.vala"
									_tmp43_ = self->priv->_schema;
#line 158 "../src/services/Settings.vala"
									_tmp44_ = g_variant_new_int64 (g_value_get_int64 (&val));
#line 158 "../src/services/Settings.vala"
									g_variant_ref_sink (_tmp44_);
#line 158 "../src/services/Settings.vala"
									_tmp45_ = _tmp44_;
#line 158 "../src/services/Settings.vala"
									res = g_settings_set_value (_tmp43_, key, _tmp45_);
#line 158 "../src/services/Settings.vala"
									_g_variant_unref0 (_tmp45_);
#line 810 "Settings.c"
								} else {
									gboolean _tmp46_ = FALSE;
#line 161 "../src/services/Settings.vala"
									if (type == G_TYPE_UINT64) {
#line 815 "Settings.c"
										GSettings* _tmp47_;
										GVariant* _tmp48_;
										GVariant* _tmp49_;
#line 162 "../src/services/Settings.vala"
										_tmp47_ = self->priv->_schema;
#line 162 "../src/services/Settings.vala"
										_tmp48_ = g_settings_get_value (_tmp47_, key);
#line 162 "../src/services/Settings.vala"
										_tmp49_ = _tmp48_;
#line 162 "../src/services/Settings.vala"
										_tmp46_ = g_value_get_uint64 (&val) != g_variant_get_uint64 (_tmp49_);
#line 162 "../src/services/Settings.vala"
										_g_variant_unref0 (_tmp49_);
#line 829 "Settings.c"
									} else {
#line 161 "../src/services/Settings.vala"
										_tmp46_ = FALSE;
#line 833 "Settings.c"
									}
#line 161 "../src/services/Settings.vala"
									if (_tmp46_) {
#line 837 "Settings.c"
										GSettings* _tmp50_;
										GVariant* _tmp51_;
										GVariant* _tmp52_;
#line 164 "../src/services/Settings.vala"
										_tmp50_ = self->priv->_schema;
#line 164 "../src/services/Settings.vala"
										_tmp51_ = g_variant_new_uint64 (g_value_get_uint64 (&val));
#line 164 "../src/services/Settings.vala"
										g_variant_ref_sink (_tmp51_);
#line 164 "../src/services/Settings.vala"
										_tmp52_ = _tmp51_;
#line 164 "../src/services/Settings.vala"
										res = g_settings_set_value (_tmp50_, key, _tmp52_);
#line 164 "../src/services/Settings.vala"
										_g_variant_unref0 (_tmp52_);
#line 853 "Settings.c"
									} else {
										gboolean _tmp53_ = FALSE;
#line 167 "../src/services/Settings.vala"
										if (G_TYPE_IS_ENUM (type)) {
#line 858 "Settings.c"
											GSettings* _tmp54_;
#line 168 "../src/services/Settings.vala"
											_tmp54_ = self->priv->_schema;
#line 168 "../src/services/Settings.vala"
											_tmp53_ = g_value_get_enum (&val) != g_settings_get_enum (_tmp54_, key);
#line 864 "Settings.c"
										} else {
#line 167 "../src/services/Settings.vala"
											_tmp53_ = FALSE;
#line 868 "Settings.c"
										}
#line 167 "../src/services/Settings.vala"
										if (_tmp53_) {
#line 872 "Settings.c"
											GSettings* _tmp55_;
#line 170 "../src/services/Settings.vala"
											_tmp55_ = self->priv->_schema;
#line 170 "../src/services/Settings.vala"
											res = g_settings_set_enum (_tmp55_, key, g_value_get_enum (&val));
#line 878 "Settings.c"
										}
									}
								}
							}
						}
					}
				}
			}
		}
	} else {
		gchar* _tmp56_;
		gchar* _tmp57_;
#line 175 "../src/services/Settings.vala"
		_tmp56_ = g_strdup_printf ("%lu", (gulong) type);
#line 175 "../src/services/Settings.vala"
		_tmp57_ = _tmp56_;
#line 175 "../src/services/Settings.vala"
		g_warning ("Settings.vala:175: Unsuported type %s for key %s", _tmp57_, key);
#line 175 "../src/services/Settings.vala"
		_g_free0 (_tmp57_);
#line 899 "Settings.c"
	}
#line 178 "../src/services/Settings.vala"
	if (!res) {
#line 179 "../src/services/Settings.vala"
		g_warning ("Settings.vala:179: Could not update %s", key);
#line 905 "Settings.c"
	}
#line 181 "../src/services/Settings.vala"
	self->priv->updating = FALSE;
#line 182 "../src/services/Settings.vala"
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _marble_settings_on_notify_g_object_notify, self, 0);
#line 99 "../src/services/Settings.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 99 "../src/services/Settings.vala"
	_g_param_spec_unref0 (prop);
#line 99 "../src/services/Settings.vala"
	_g_type_class_unref0 (obj_class);
#line 917 "Settings.c"
}

static void
marble_settings_on_notify (MarbleSettings* self,
                           GObject* sender,
                           GParamSpec* prop)
{
	const gchar* _tmp0_;
#line 185 "../src/services/Settings.vala"
	g_return_if_fail (self != NULL);
#line 185 "../src/services/Settings.vala"
	g_return_if_fail (sender != NULL);
#line 185 "../src/services/Settings.vala"
	g_return_if_fail (prop != NULL);
#line 187 "../src/services/Settings.vala"
	_tmp0_ = prop->name;
#line 187 "../src/services/Settings.vala"
	marble_settings_save_key (self, _tmp0_);
#line 936 "Settings.c"
}

GSettings*
marble_settings_get_schema (MarbleSettings* self)
{
	GSettings* result;
	GSettings* _tmp0_;
#line 28 "../src/services/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/services/Settings.vala"
	_tmp0_ = self->priv->_schema;
#line 28 "../src/services/Settings.vala"
	result = _tmp0_;
#line 28 "../src/services/Settings.vala"
	return result;
#line 952 "Settings.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 28 "../src/services/Settings.vala"
	return self ? g_object_ref (self) : NULL;
#line 960 "Settings.c"
}

void
marble_settings_set_schema (MarbleSettings* self,
                            GSettings* value)
{
	GSettings* old_value;
#line 28 "../src/services/Settings.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/services/Settings.vala"
	old_value = marble_settings_get_schema (self);
#line 28 "../src/services/Settings.vala"
	if (old_value != value) {
#line 974 "Settings.c"
		GSettings* _tmp0_;
#line 28 "../src/services/Settings.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 28 "../src/services/Settings.vala"
		_g_object_unref0 (self->priv->_schema);
#line 28 "../src/services/Settings.vala"
		self->priv->_schema = _tmp0_;
#line 28 "../src/services/Settings.vala"
		g_object_notify_by_pspec ((GObject *) self, marble_settings_properties[MARBLE_SETTINGS_SCHEMA_PROPERTY]);
#line 984 "Settings.c"
	}
}

static void
_marble_settings_load_key_g_settings_changed (GSettings* _sender,
                                              const gchar* key,
                                              gpointer self)
{
#line 49 "../src/services/Settings.vala"
	marble_settings_load_key ((MarbleSettings*) self, key);
#line 995 "Settings.c"
}

static GObject *
marble_settings_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MarbleSettings * self;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GObjectClass* obj_class = NULL;
	GTypeClass* _tmp4_;
	GParamSpec** properties = NULL;
	GObjectClass* _tmp5_;
	guint _tmp6_ = 0;
	GParamSpec** _tmp7_;
	gint properties_length1;
	gint _properties_size_;
	GParamSpec** _tmp8_;
	gint _tmp8__length1;
	GSettings* _tmp11_;
#line 39 "../src/services/Settings.vala"
	parent_class = G_OBJECT_CLASS (marble_settings_parent_class);
#line 39 "../src/services/Settings.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 39 "../src/services/Settings.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MARBLE_TYPE_SETTINGS, MarbleSettings);
#line 41 "../src/services/Settings.vala"
	_tmp0_ = self->priv->_schema;
#line 41 "../src/services/Settings.vala"
	g_object_get (_tmp0_, "schema-id", &_tmp1_, NULL);
#line 41 "../src/services/Settings.vala"
	_tmp2_ = _tmp1_;
#line 41 "../src/services/Settings.vala"
	_tmp3_ = _tmp2_;
#line 41 "../src/services/Settings.vala"
	g_debug ("Settings.vala:41: Started settings from '%s'", _tmp3_);
#line 41 "../src/services/Settings.vala"
	_g_free0 (_tmp3_);
#line 43 "../src/services/Settings.vala"
	_tmp4_ = g_type_class_ref (G_TYPE_FROM_INSTANCE ((GObject*) self));
#line 43 "../src/services/Settings.vala"
	obj_class = (GObjectClass*) _tmp4_;
#line 44 "../src/services/Settings.vala"
	_tmp5_ = obj_class;
#line 44 "../src/services/Settings.vala"
	_tmp7_ = g_object_class_list_properties (_tmp5_, &_tmp6_);
#line 44 "../src/services/Settings.vala"
	properties = _tmp7_;
#line 44 "../src/services/Settings.vala"
	properties_length1 = _tmp6_;
#line 44 "../src/services/Settings.vala"
	_properties_size_ = properties_length1;
#line 45 "../src/services/Settings.vala"
	_tmp8_ = properties;
#line 45 "../src/services/Settings.vala"
	_tmp8__length1 = properties_length1;
#line 1057 "Settings.c"
	{
		GParamSpec** prop_collection = NULL;
		gint prop_collection_length1 = 0;
		gint _prop_collection_size_ = 0;
		gint prop_it = 0;
#line 45 "../src/services/Settings.vala"
		prop_collection = _tmp8_;
#line 45 "../src/services/Settings.vala"
		prop_collection_length1 = _tmp8__length1;
#line 45 "../src/services/Settings.vala"
		for (prop_it = 0; prop_it < prop_collection_length1; prop_it = prop_it + 1) {
#line 1069 "Settings.c"
			GParamSpec* prop = NULL;
#line 45 "../src/services/Settings.vala"
			prop = prop_collection[prop_it];
#line 1073 "Settings.c"
			{
				GParamSpec* _tmp9_;
				const gchar* _tmp10_;
#line 46 "../src/services/Settings.vala"
				_tmp9_ = prop;
#line 46 "../src/services/Settings.vala"
				_tmp10_ = _tmp9_->name;
#line 46 "../src/services/Settings.vala"
				marble_settings_load_key (self, _tmp10_);
#line 1083 "Settings.c"
			}
		}
	}
#line 48 "../src/services/Settings.vala"
	self->priv->doing_setup = FALSE;
#line 49 "../src/services/Settings.vala"
	_tmp11_ = self->priv->_schema;
#line 49 "../src/services/Settings.vala"
	g_signal_connect_object (_tmp11_, "changed", (GCallback) _marble_settings_load_key_g_settings_changed, self, 0);
#line 39 "../src/services/Settings.vala"
	properties = (g_free (properties), NULL);
#line 39 "../src/services/Settings.vala"
	_g_type_class_unref0 (obj_class);
#line 39 "../src/services/Settings.vala"
	return obj;
#line 1099 "Settings.c"
}

static void
marble_settings_class_init (MarbleSettingsClass * klass,
                            gpointer klass_data)
{
#line 26 "../src/services/Settings.vala"
	marble_settings_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/services/Settings.vala"
	g_type_class_adjust_private_offset (klass, &MarbleSettings_private_offset);
#line 26 "../src/services/Settings.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_marble_settings_get_property;
#line 26 "../src/services/Settings.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_marble_settings_set_property;
#line 26 "../src/services/Settings.vala"
	G_OBJECT_CLASS (klass)->constructor = marble_settings_constructor;
#line 26 "../src/services/Settings.vala"
	G_OBJECT_CLASS (klass)->finalize = marble_settings_finalize;
#line 26 "../src/services/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MARBLE_SETTINGS_SCHEMA_PROPERTY, marble_settings_properties[MARBLE_SETTINGS_SCHEMA_PROPERTY] = g_param_spec_object ("schema", "schema", "schema", g_settings_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1120 "Settings.c"
}

static void
marble_settings_instance_init (MarbleSettings * self,
                               gpointer klass)
{
#line 26 "../src/services/Settings.vala"
	self->priv = marble_settings_get_instance_private (self);
#line 30 "../src/services/Settings.vala"
	self->priv->updating = FALSE;
#line 31 "../src/services/Settings.vala"
	self->priv->doing_setup = TRUE;
#line 1133 "Settings.c"
}

static void
marble_settings_finalize (GObject * obj)
{
	MarbleSettings * self;
#line 26 "../src/services/Settings.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MARBLE_TYPE_SETTINGS, MarbleSettings);
#line 28 "../src/services/Settings.vala"
	_g_object_unref0 (self->priv->_schema);
#line 26 "../src/services/Settings.vala"
	G_OBJECT_CLASS (marble_settings_parent_class)->finalize (obj);
#line 1146 "Settings.c"
}

static GType
marble_settings_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MarbleSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) marble_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MarbleSettings), 0, (GInstanceInitFunc) marble_settings_instance_init, NULL };
	GType marble_settings_type_id;
	marble_settings_type_id = g_type_register_static (G_TYPE_OBJECT, "MarbleSettings", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	MarbleSettings_private_offset = g_type_add_instance_private (marble_settings_type_id, sizeof (MarbleSettingsPrivate));
	return marble_settings_type_id;
}

GType
marble_settings_get_type (void)
{
	static volatile gsize marble_settings_type_id__once = 0;
	if (g_once_init_enter (&marble_settings_type_id__once)) {
		GType marble_settings_type_id;
		marble_settings_type_id = marble_settings_get_type_once ();
		g_once_init_leave (&marble_settings_type_id__once, marble_settings_type_id);
	}
	return marble_settings_type_id__once;
}

static void
_vala_marble_settings_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	MarbleSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MARBLE_TYPE_SETTINGS, MarbleSettings);
#line 26 "../src/services/Settings.vala"
	switch (property_id) {
#line 26 "../src/services/Settings.vala"
		case MARBLE_SETTINGS_SCHEMA_PROPERTY:
#line 26 "../src/services/Settings.vala"
		g_value_set_object (value, marble_settings_get_schema (self));
#line 26 "../src/services/Settings.vala"
		break;
#line 1187 "Settings.c"
		default:
#line 26 "../src/services/Settings.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/services/Settings.vala"
		break;
#line 1193 "Settings.c"
	}
}

static void
_vala_marble_settings_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	MarbleSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MARBLE_TYPE_SETTINGS, MarbleSettings);
#line 26 "../src/services/Settings.vala"
	switch (property_id) {
#line 26 "../src/services/Settings.vala"
		case MARBLE_SETTINGS_SCHEMA_PROPERTY:
#line 26 "../src/services/Settings.vala"
		marble_settings_set_schema (self, g_value_get_object (value));
#line 26 "../src/services/Settings.vala"
		break;
#line 1213 "Settings.c"
		default:
#line 26 "../src/services/Settings.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/services/Settings.vala"
		break;
#line 1219 "Settings.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

