/* Utils.c generated by valac 0.56.17, the Vala compiler
 * generated from Utils.vala, do not modify */

/* Utils.vala
 *
 * Copyright 2019 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include "marble.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

GtkCssProvider*
marble_get_css_provider_for_data (const gchar* data)
{
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp0_;
	GError* _inner_error0_ = NULL;
	GtkCssProvider* result;
#line 29 "../src/utils/Utils.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 31 "../src/utils/Utils.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 31 "../src/utils/Utils.vala"
	provider = _tmp0_;
#line 57 "Utils.c"
	{
		GtkCssProvider* _tmp1_;
#line 35 "../src/utils/Utils.vala"
		_tmp1_ = provider;
#line 35 "../src/utils/Utils.vala"
		gtk_css_provider_load_from_data (_tmp1_, data, (gssize) -1, &_inner_error0_);
#line 35 "../src/utils/Utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 66 "Utils.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 33 "../src/utils/Utils.vala"
		e = _inner_error0_;
#line 33 "../src/utils/Utils.vala"
		_inner_error0_ = NULL;
#line 39 "../src/utils/Utils.vala"
		_tmp2_ = e;
#line 39 "../src/utils/Utils.vala"
		_tmp3_ = _tmp2_->message;
#line 39 "../src/utils/Utils.vala"
		g_warning ("Utils.vala:39: %s", _tmp3_);
#line 40 "../src/utils/Utils.vala"
		result = NULL;
#line 40 "../src/utils/Utils.vala"
		_g_error_free0 (e);
#line 40 "../src/utils/Utils.vala"
		_g_object_unref0 (provider);
#line 40 "../src/utils/Utils.vala"
		return result;
#line 94 "Utils.c"
	}
	__finally0:
#line 33 "../src/utils/Utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 33 "../src/utils/Utils.vala"
		_g_object_unref0 (provider);
#line 33 "../src/utils/Utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 33 "../src/utils/Utils.vala"
		g_clear_error (&_inner_error0_);
#line 33 "../src/utils/Utils.vala"
		return NULL;
#line 107 "Utils.c"
	}
#line 43 "../src/utils/Utils.vala"
	result = provider;
#line 43 "../src/utils/Utils.vala"
	return result;
#line 113 "Utils.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 58 "../src/utils/Utils.vala"
	return self ? g_object_ref (self) : NULL;
#line 121 "Utils.c"
}

void
marble_set_theming_for_data (GtkWidget* widget,
                             const gchar* data,
                             const gchar* class_name,
                             gint priority)
{
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp0_;
	GtkStyleContext* ctx = NULL;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkCssProvider* _tmp3_;
#line 52 "../src/utils/Utils.vala"
	g_return_if_fail (widget != NULL);
#line 52 "../src/utils/Utils.vala"
	g_return_if_fail (data != NULL);
#line 56 "../src/utils/Utils.vala"
	_tmp0_ = marble_get_css_provider_for_data (data);
#line 56 "../src/utils/Utils.vala"
	provider = _tmp0_;
#line 58 "../src/utils/Utils.vala"
	_tmp1_ = gtk_widget_get_style_context (widget);
#line 58 "../src/utils/Utils.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 58 "../src/utils/Utils.vala"
	ctx = _tmp2_;
#line 60 "../src/utils/Utils.vala"
	_tmp3_ = provider;
#line 60 "../src/utils/Utils.vala"
	if (_tmp3_ != NULL) {
#line 154 "Utils.c"
		GtkStyleContext* _tmp4_;
		GtkCssProvider* _tmp5_;
#line 61 "../src/utils/Utils.vala"
		_tmp4_ = ctx;
#line 61 "../src/utils/Utils.vala"
		_tmp5_ = provider;
#line 61 "../src/utils/Utils.vala"
		gtk_style_context_add_provider (_tmp4_, (GtkStyleProvider*) _tmp5_, (guint) priority);
#line 163 "Utils.c"
	}
#line 63 "../src/utils/Utils.vala"
	if (class_name != NULL) {
#line 167 "Utils.c"
		GtkStyleContext* _tmp6_;
#line 64 "../src/utils/Utils.vala"
		_tmp6_ = ctx;
#line 64 "../src/utils/Utils.vala"
		gtk_style_context_add_class (_tmp6_, class_name);
#line 173 "Utils.c"
	}
#line 52 "../src/utils/Utils.vala"
	_g_object_unref0 (ctx);
#line 52 "../src/utils/Utils.vala"
	_g_object_unref0 (provider);
#line 179 "Utils.c"
}

void
marble_add_css_provider_from_resource (const gchar* resource,
                                       gint priority,
                                       GdkScreen* screen)
{
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp0_;
#line 67 "../src/utils/Utils.vala"
	g_return_if_fail (resource != NULL);
#line 67 "../src/utils/Utils.vala"
	g_return_if_fail (screen != NULL);
#line 71 "../src/utils/Utils.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 71 "../src/utils/Utils.vala"
	provider = _tmp0_;
#line 73 "../src/utils/Utils.vala"
	gtk_css_provider_load_from_resource (provider, resource);
#line 74 "../src/utils/Utils.vala"
	gtk_style_context_add_provider_for_screen (screen, (GtkStyleProvider*) provider, (guint) priority);
#line 67 "../src/utils/Utils.vala"
	_g_object_unref0 (provider);
#line 203 "Utils.c"
}

