/* Progressable.c generated by valac 0.56.17, the Vala compiler
 * generated from Progressable.vala, do not modify */

/* Progressable.vala
 *
 * Copyright 2019 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include "marble.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>

#define MARBLE_PROGRESSABLE_DEFAULT_STYLE "\n" \
"        .loadable > progressbar {\n" \
"            background: alpha(darker(@theme_bg_color), .6);\n" \
"        }\n" \
"    "
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	MARBLE_PROGRESSABLE_0_PROPERTY,
	MARBLE_PROGRESSABLE_LOADING_PROPERTY,
	MARBLE_PROGRESSABLE_PROGRESS_BAR_PROPERTY,
	MARBLE_PROGRESSABLE_NUM_PROPERTIES
};
static GParamSpec* marble_progressable_properties[MARBLE_PROGRESSABLE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _MarbleProgressablePrivate {
	gboolean _loading;
	GtkProgressBar* _progress_bar;
};

static gint MarbleProgressable_private_offset;
static gpointer marble_progressable_parent_class = NULL;

static void marble_progressable_loading_changed (MarbleProgressable* self);
static void _marble_progressable_loading_changed_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self);
static gboolean __lambda4_ (MarbleProgressable* self);
static gboolean ___lambda4__gsource_func (gpointer self);
static void marble_progressable_finalize (GObject * obj);
static GType marble_progressable_get_type_once (void);
static void _vala_marble_progressable_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_marble_progressable_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
marble_progressable_get_instance_private (MarbleProgressable* self)
{
	return G_STRUCT_MEMBER_P (self, MarbleProgressable_private_offset);
}

/**
     * Creates a new {@link Marble.Progressable}.
     */
static void
_marble_progressable_loading_changed_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self)
{
#line 53 "../src/widgets/Progressable.vala"
	marble_progressable_loading_changed ((MarbleProgressable*) self);
#line 92 "Progressable.c"
}

MarbleProgressable*
marble_progressable_construct (GType object_type)
{
	MarbleProgressable * self = NULL;
	GtkProgressBar* _tmp0_;
	GtkProgressBar* _tmp1_;
	GtkProgressBar* _tmp2_;
	GtkProgressBar* _tmp3_;
	GtkProgressBar* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkProgressBar* _tmp6_;
#line 45 "../src/widgets/Progressable.vala"
	self = (MarbleProgressable*) g_object_new (object_type, NULL);
#line 47 "../src/widgets/Progressable.vala"
	_tmp0_ = (GtkProgressBar*) gtk_progress_bar_new ();
#line 47 "../src/widgets/Progressable.vala"
	g_object_ref_sink (_tmp0_);
#line 47 "../src/widgets/Progressable.vala"
	_tmp1_ = _tmp0_;
#line 47 "../src/widgets/Progressable.vala"
	marble_progressable_set_progress_bar (self, _tmp1_);
#line 47 "../src/widgets/Progressable.vala"
	_g_object_unref0 (_tmp1_);
#line 48 "../src/widgets/Progressable.vala"
	_tmp2_ = self->priv->_progress_bar;
#line 48 "../src/widgets/Progressable.vala"
	gtk_progress_bar_set_pulse_step (_tmp2_, 0.5);
#line 50 "../src/widgets/Progressable.vala"
	_tmp3_ = self->priv->_progress_bar;
#line 50 "../src/widgets/Progressable.vala"
	gtk_overlay_add_overlay ((GtkOverlay*) self, (GtkWidget*) _tmp3_);
#line 51 "../src/widgets/Progressable.vala"
	_tmp4_ = self->priv->_progress_bar;
#line 51 "../src/widgets/Progressable.vala"
	gtk_overlay_set_overlay_pass_through ((GtkOverlay*) self, (GtkWidget*) _tmp4_, FALSE);
#line 53 "../src/widgets/Progressable.vala"
	g_signal_connect_object ((GObject*) self, "notify::loading", (GCallback) _marble_progressable_loading_changed_g_object_notify, self, 0);
#line 55 "../src/widgets/Progressable.vala"
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 55 "../src/widgets/Progressable.vala"
	gtk_style_context_add_class (_tmp5_, "loadable");
#line 56 "../src/widgets/Progressable.vala"
	_tmp6_ = self->priv->_progress_bar;
#line 56 "../src/widgets/Progressable.vala"
	marble_set_theming_for_data ((GtkWidget*) _tmp6_, MARBLE_PROGRESSABLE_DEFAULT_STYLE, NULL, GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 45 "../src/widgets/Progressable.vala"
	return self;
#line 142 "Progressable.c"
}

MarbleProgressable*
marble_progressable_new (void)
{
#line 45 "../src/widgets/Progressable.vala"
	return marble_progressable_construct (MARBLE_TYPE_PROGRESSABLE);
#line 150 "Progressable.c"
}

static void
marble_progressable_loading_changed (MarbleProgressable* self)
{
	gboolean _tmp0_;
#line 60 "../src/widgets/Progressable.vala"
	g_return_if_fail (self != NULL);
#line 62 "../src/widgets/Progressable.vala"
	_tmp0_ = self->priv->_loading;
#line 62 "../src/widgets/Progressable.vala"
	if (_tmp0_) {
#line 163 "Progressable.c"
		GtkProgressBar* _tmp1_;
#line 63 "../src/widgets/Progressable.vala"
		_tmp1_ = self->priv->_progress_bar;
#line 63 "../src/widgets/Progressable.vala"
		gtk_widget_show ((GtkWidget*) _tmp1_);
#line 169 "Progressable.c"
	} else {
		GtkProgressBar* _tmp2_;
#line 65 "../src/widgets/Progressable.vala"
		_tmp2_ = self->priv->_progress_bar;
#line 65 "../src/widgets/Progressable.vala"
		gtk_widget_hide ((GtkWidget*) _tmp2_);
#line 176 "Progressable.c"
	}
}

/**
     * Make ``this.progress_bar`` start pulsating in an infinite loop.
     *
     * @return always return false
     */
static gboolean
__lambda4_ (MarbleProgressable* self)
{
	gboolean result;
#line 77 "../src/widgets/Progressable.vala"
	result = marble_progressable_pulse (self);
#line 77 "../src/widgets/Progressable.vala"
	return result;
#line 193 "Progressable.c"
}

static gboolean
___lambda4__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda4_ ((MarbleProgressable*) self);
#line 77 "../src/widgets/Progressable.vala"
	return result;
#line 203 "Progressable.c"
}

gboolean
marble_progressable_pulse (MarbleProgressable* self)
{
	GtkProgressBar* _tmp0_;
	gboolean result;
#line 73 "../src/widgets/Progressable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 75 "../src/widgets/Progressable.vala"
	_tmp0_ = self->priv->_progress_bar;
#line 75 "../src/widgets/Progressable.vala"
	gtk_progress_bar_pulse (_tmp0_);
#line 77 "../src/widgets/Progressable.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1500, ___lambda4__gsource_func, g_object_ref (self), g_object_unref);
#line 79 "../src/widgets/Progressable.vala"
	result = FALSE;
#line 79 "../src/widgets/Progressable.vala"
	return result;
#line 223 "Progressable.c"
}

gboolean
marble_progressable_get_loading (MarbleProgressable* self)
{
	gboolean result;
#line 32 "../src/widgets/Progressable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 32 "../src/widgets/Progressable.vala"
	result = self->priv->_loading;
#line 32 "../src/widgets/Progressable.vala"
	return result;
#line 236 "Progressable.c"
}

void
marble_progressable_set_loading (MarbleProgressable* self,
                                 gboolean value)
{
	gboolean old_value;
#line 32 "../src/widgets/Progressable.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/widgets/Progressable.vala"
	old_value = marble_progressable_get_loading (self);
#line 32 "../src/widgets/Progressable.vala"
	if (old_value != value) {
#line 32 "../src/widgets/Progressable.vala"
		self->priv->_loading = value;
#line 32 "../src/widgets/Progressable.vala"
		g_object_notify_by_pspec ((GObject *) self, marble_progressable_properties[MARBLE_PROGRESSABLE_LOADING_PROPERTY]);
#line 254 "Progressable.c"
	}
}

GtkProgressBar*
marble_progressable_get_progress_bar (MarbleProgressable* self)
{
	GtkProgressBar* result;
	GtkProgressBar* _tmp0_;
#line 34 "../src/widgets/Progressable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/widgets/Progressable.vala"
	_tmp0_ = self->priv->_progress_bar;
#line 34 "../src/widgets/Progressable.vala"
	result = _tmp0_;
#line 34 "../src/widgets/Progressable.vala"
	return result;
#line 271 "Progressable.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 34 "../src/widgets/Progressable.vala"
	return self ? g_object_ref (self) : NULL;
#line 279 "Progressable.c"
}

void
marble_progressable_set_progress_bar (MarbleProgressable* self,
                                      GtkProgressBar* value)
{
	GtkProgressBar* old_value;
#line 34 "../src/widgets/Progressable.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/widgets/Progressable.vala"
	old_value = marble_progressable_get_progress_bar (self);
#line 34 "../src/widgets/Progressable.vala"
	if (old_value != value) {
#line 293 "Progressable.c"
		GtkProgressBar* _tmp0_;
#line 34 "../src/widgets/Progressable.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 34 "../src/widgets/Progressable.vala"
		_g_object_unref0 (self->priv->_progress_bar);
#line 34 "../src/widgets/Progressable.vala"
		self->priv->_progress_bar = _tmp0_;
#line 34 "../src/widgets/Progressable.vala"
		g_object_notify_by_pspec ((GObject *) self, marble_progressable_properties[MARBLE_PROGRESSABLE_PROGRESS_BAR_PROPERTY]);
#line 303 "Progressable.c"
	}
}

static void
marble_progressable_class_init (MarbleProgressableClass * klass,
                                gpointer klass_data)
{
#line 27 "../src/widgets/Progressable.vala"
	marble_progressable_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/widgets/Progressable.vala"
	g_type_class_adjust_private_offset (klass, &MarbleProgressable_private_offset);
#line 27 "../src/widgets/Progressable.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_marble_progressable_get_property;
#line 27 "../src/widgets/Progressable.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_marble_progressable_set_property;
#line 27 "../src/widgets/Progressable.vala"
	G_OBJECT_CLASS (klass)->finalize = marble_progressable_finalize;
#line 321 "Progressable.c"
	/**
	     * Whether or not the widget is working. ``False`` by default.
	     */
#line 27 "../src/widgets/Progressable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MARBLE_PROGRESSABLE_LOADING_PROPERTY, marble_progressable_properties[MARBLE_PROGRESSABLE_LOADING_PROPERTY] = g_param_spec_boolean ("loading", "loading", "loading", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/widgets/Progressable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MARBLE_PROGRESSABLE_PROGRESS_BAR_PROPERTY, marble_progressable_properties[MARBLE_PROGRESSABLE_PROGRESS_BAR_PROPERTY] = g_param_spec_object ("progress-bar", "progress-bar", "progress-bar", gtk_progress_bar_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 329 "Progressable.c"
}

static void
marble_progressable_instance_init (MarbleProgressable * self,
                                   gpointer klass)
{
#line 27 "../src/widgets/Progressable.vala"
	self->priv = marble_progressable_get_instance_private (self);
#line 32 "../src/widgets/Progressable.vala"
	self->priv->_loading = FALSE;
#line 340 "Progressable.c"
}

static void
marble_progressable_finalize (GObject * obj)
{
	MarbleProgressable * self;
#line 27 "../src/widgets/Progressable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MARBLE_TYPE_PROGRESSABLE, MarbleProgressable);
#line 34 "../src/widgets/Progressable.vala"
	_g_object_unref0 (self->priv->_progress_bar);
#line 27 "../src/widgets/Progressable.vala"
	G_OBJECT_CLASS (marble_progressable_parent_class)->finalize (obj);
#line 353 "Progressable.c"
}

/**
 * Progressable is a {@link Gtk.Overlay} that allows you to quickly toggle an
 * overlayed {@link Gtk.ProgressBar} on top of it's content. Useful when you run
 * async operations and need to let the user know something is being done in the
 * background.
 */
static GType
marble_progressable_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MarbleProgressableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) marble_progressable_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MarbleProgressable), 0, (GInstanceInitFunc) marble_progressable_instance_init, NULL };
	GType marble_progressable_type_id;
	marble_progressable_type_id = g_type_register_static (gtk_overlay_get_type (), "MarbleProgressable", &g_define_type_info, 0);
	MarbleProgressable_private_offset = g_type_add_instance_private (marble_progressable_type_id, sizeof (MarbleProgressablePrivate));
	return marble_progressable_type_id;
}

GType
marble_progressable_get_type (void)
{
	static volatile gsize marble_progressable_type_id__once = 0;
	if (g_once_init_enter (&marble_progressable_type_id__once)) {
		GType marble_progressable_type_id;
		marble_progressable_type_id = marble_progressable_get_type_once ();
		g_once_init_leave (&marble_progressable_type_id__once, marble_progressable_type_id);
	}
	return marble_progressable_type_id__once;
}

static void
_vala_marble_progressable_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	MarbleProgressable * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MARBLE_TYPE_PROGRESSABLE, MarbleProgressable);
#line 27 "../src/widgets/Progressable.vala"
	switch (property_id) {
#line 27 "../src/widgets/Progressable.vala"
		case MARBLE_PROGRESSABLE_LOADING_PROPERTY:
#line 27 "../src/widgets/Progressable.vala"
		g_value_set_boolean (value, marble_progressable_get_loading (self));
#line 27 "../src/widgets/Progressable.vala"
		break;
#line 27 "../src/widgets/Progressable.vala"
		case MARBLE_PROGRESSABLE_PROGRESS_BAR_PROPERTY:
#line 27 "../src/widgets/Progressable.vala"
		g_value_set_object (value, marble_progressable_get_progress_bar (self));
#line 27 "../src/widgets/Progressable.vala"
		break;
#line 406 "Progressable.c"
		default:
#line 27 "../src/widgets/Progressable.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/widgets/Progressable.vala"
		break;
#line 412 "Progressable.c"
	}
}

static void
_vala_marble_progressable_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	MarbleProgressable * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MARBLE_TYPE_PROGRESSABLE, MarbleProgressable);
#line 27 "../src/widgets/Progressable.vala"
	switch (property_id) {
#line 27 "../src/widgets/Progressable.vala"
		case MARBLE_PROGRESSABLE_LOADING_PROPERTY:
#line 27 "../src/widgets/Progressable.vala"
		marble_progressable_set_loading (self, g_value_get_boolean (value));
#line 27 "../src/widgets/Progressable.vala"
		break;
#line 27 "../src/widgets/Progressable.vala"
		case MARBLE_PROGRESSABLE_PROGRESS_BAR_PROPERTY:
#line 27 "../src/widgets/Progressable.vala"
		marble_progressable_set_progress_bar (self, g_value_get_object (value));
#line 27 "../src/widgets/Progressable.vala"
		break;
#line 438 "Progressable.c"
		default:
#line 27 "../src/widgets/Progressable.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/widgets/Progressable.vala"
		break;
#line 444 "Progressable.c"
	}
}

