/* SideWindow.c generated by valac 0.56.17, the Vala compiler
 * generated from SideWindow.vala, do not modify */

/* SideWindow.vala
 *
 * Copyright 2020 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include "marble.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	MARBLE_SIDE_WINDOW_0_PROPERTY,
	MARBLE_SIDE_WINDOW_DARK_MODE_PROPERTY,
	MARBLE_SIDE_WINDOW_SHOW_WINDOW_CONTROLS_PROPERTY,
	MARBLE_SIDE_WINDOW_TITLE_PROPERTY,
	MARBLE_SIDE_WINDOW_NUM_PROPERTIES
};
static GParamSpec* marble_side_window_properties[MARBLE_SIDE_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _MarbleSideWindowPrivate {
	gboolean _dark_mode;
	gboolean _show_window_controls;
	gchar* _title;
	GtkSizeGroup* size_group;
};

static gint MarbleSideWindow_private_offset;
static gpointer marble_side_window_parent_class = NULL;

static void marble_side_window_connect_signals (MarbleSideWindow* self);
static void marble_side_window_update_headerbar_controls (MarbleSideWindow* self);
static void marble_side_window_on_notify (MarbleSideWindow* self,
                                   GParamSpec* s);
static void _marble_side_window_on_notify_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static GObject * marble_side_window_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void marble_side_window_finalize (GObject * obj);
static GType marble_side_window_get_type_once (void);
static void _vala_marble_side_window_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_marble_side_window_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);

static inline gpointer
marble_side_window_get_instance_private (MarbleSideWindow* self)
{
	return G_STRUCT_MEMBER_P (self, MarbleSideWindow_private_offset);
}

MarbleSideWindow*
marble_side_window_construct (GType object_type,
                              GtkApplication* app)
{
	MarbleSideWindow * self = NULL;
	GtkCssProvider* css_provider = NULL;
	GtkCssProvider* _tmp0_;
	GdkScreen* _tmp1_;
#line 65 "../src/widgets/SideWindow.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 67 "../src/widgets/SideWindow.vala"
	self = (MarbleSideWindow*) g_object_new (object_type, "application", app, NULL);
#line 69 "../src/widgets/SideWindow.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 69 "../src/widgets/SideWindow.vala"
	css_provider = _tmp0_;
#line 70 "../src/widgets/SideWindow.vala"
	gtk_css_provider_load_from_resource (css_provider, "/com/raggesilver/Marble/resources/sidewindow.css");
#line 73 "../src/widgets/SideWindow.vala"
	_tmp1_ = gdk_screen_get_default ();
#line 73 "../src/widgets/SideWindow.vala"
	gtk_style_context_add_provider_for_screen (_tmp1_, (GtkStyleProvider*) css_provider, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 78 "../src/widgets/SideWindow.vala"
	marble_side_window_connect_signals (self);
#line 65 "../src/widgets/SideWindow.vala"
	_g_object_unref0 (css_provider);
#line 65 "../src/widgets/SideWindow.vala"
	return self;
#line 118 "SideWindow.c"
}

MarbleSideWindow*
marble_side_window_new (GtkApplication* app)
{
#line 65 "../src/widgets/SideWindow.vala"
	return marble_side_window_construct (MARBLE_TYPE_SIDE_WINDOW, app);
#line 126 "SideWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 83 "../src/widgets/SideWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 134 "SideWindow.c"
}

static void
_marble_side_window_on_notify_g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
#line 88 "../src/widgets/SideWindow.vala"
	marble_side_window_on_notify ((MarbleSideWindow*) self, pspec);
#line 144 "SideWindow.c"
}

static void
marble_side_window_connect_signals (MarbleSideWindow* self)
{
	GtkSettings* settings = NULL;
	GtkSettings* _tmp0_;
	GtkSettings* _tmp1_;
	gboolean _tmp2_;
#line 81 "../src/widgets/SideWindow.vala"
	g_return_if_fail (self != NULL);
#line 83 "../src/widgets/SideWindow.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 83 "../src/widgets/SideWindow.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 83 "../src/widgets/SideWindow.vala"
	settings = _tmp1_;
#line 85 "../src/widgets/SideWindow.vala"
	_tmp2_ = self->priv->_dark_mode;
#line 85 "../src/widgets/SideWindow.vala"
	g_object_set (settings, "gtk-application-prefer-dark-theme", _tmp2_, NULL);
#line 86 "../src/widgets/SideWindow.vala"
	marble_side_window_update_headerbar_controls (self);
#line 88 "../src/widgets/SideWindow.vala"
	g_signal_connect_object ((GObject*) settings, "notify::gtk-decoration-layout", (GCallback) _marble_side_window_on_notify_g_object_notify, self, 0);
#line 89 "../src/widgets/SideWindow.vala"
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _marble_side_window_on_notify_g_object_notify, self, 0);
#line 81 "../src/widgets/SideWindow.vala"
	_g_object_unref0 (settings);
#line 174 "SideWindow.c"
}

static void
marble_side_window_on_notify (MarbleSideWindow* self,
                              GParamSpec* s)
{
	GtkSettings* settings = NULL;
	GtkSettings* _tmp0_;
	GtkSettings* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GQuark _tmp5_ = 0U;
#line 96 "../src/widgets/SideWindow.vala"
	static GQuark _tmp4_label0 = 0;
#line 96 "../src/widgets/SideWindow.vala"
	static GQuark _tmp4_label1 = 0;
#line 96 "../src/widgets/SideWindow.vala"
	static GQuark _tmp4_label2 = 0;
#line 96 "../src/widgets/SideWindow.vala"
	static GQuark _tmp4_label3 = 0;
#line 92 "../src/widgets/SideWindow.vala"
	g_return_if_fail (self != NULL);
#line 92 "../src/widgets/SideWindow.vala"
	g_return_if_fail (s != NULL);
#line 94 "../src/widgets/SideWindow.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 94 "../src/widgets/SideWindow.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 94 "../src/widgets/SideWindow.vala"
	settings = _tmp1_;
#line 96 "../src/widgets/SideWindow.vala"
	_tmp2_ = s->name;
#line 96 "../src/widgets/SideWindow.vala"
	_tmp3_ = _tmp2_;
#line 96 "../src/widgets/SideWindow.vala"
	_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
#line 96 "../src/widgets/SideWindow.vala"
	if (_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("dark-mode")))) {
#line 96 "../src/widgets/SideWindow.vala"
		switch (0) {
#line 215 "SideWindow.c"
			default:
			{
				{
					GtkSettings* _tmp6_;
					gboolean _tmp7_;
#line 100 "../src/widgets/SideWindow.vala"
					_tmp6_ = settings;
#line 100 "../src/widgets/SideWindow.vala"
					_tmp7_ = self->priv->_dark_mode;
#line 100 "../src/widgets/SideWindow.vala"
					g_object_set (_tmp6_, "gtk-application-prefer-dark-theme", _tmp7_, NULL);
#line 101 "../src/widgets/SideWindow.vala"
					break;
#line 229 "SideWindow.c"
				}
			}
		}
	} else if ((_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("gtk-decoration-layout")))) || (_tmp5_ == ((0 != _tmp4_label2) ? _tmp4_label2 : (_tmp4_label2 = g_quark_from_static_string ("show-window-controls"))))) {
#line 96 "../src/widgets/SideWindow.vala"
		switch (0) {
#line 236 "SideWindow.c"
			default:
			{
				{
#line 106 "../src/widgets/SideWindow.vala"
					marble_side_window_update_headerbar_controls (self);
#line 107 "../src/widgets/SideWindow.vala"
					break;
#line 244 "SideWindow.c"
				}
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label3) ? _tmp4_label3 : (_tmp4_label3 = g_quark_from_static_string ("title")))) {
#line 96 "../src/widgets/SideWindow.vala"
		switch (0) {
#line 251 "SideWindow.c"
			default:
			{
				{
					GtkHeaderBar* _tmp8_;
					const gchar* _tmp9_;
#line 111 "../src/widgets/SideWindow.vala"
					_tmp8_ = self->headerbar;
#line 111 "../src/widgets/SideWindow.vala"
					_tmp9_ = self->priv->_title;
#line 111 "../src/widgets/SideWindow.vala"
					gtk_header_bar_set_title (_tmp8_, _tmp9_);
#line 112 "../src/widgets/SideWindow.vala"
					break;
#line 265 "SideWindow.c"
				}
			}
		}
	} else {
#line 96 "../src/widgets/SideWindow.vala"
		switch (0) {
#line 272 "SideWindow.c"
			default:
			{
#line 114 "../src/widgets/SideWindow.vala"
				_g_object_unref0 (settings);
#line 114 "../src/widgets/SideWindow.vala"
				return;
#line 279 "SideWindow.c"
			}
		}
	}
#line 92 "../src/widgets/SideWindow.vala"
	_g_object_unref0 (settings);
#line 285 "SideWindow.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 304 "SideWindow.c"
}

static void
marble_side_window_update_headerbar_controls (MarbleSideWindow* self)
{
	gchar* layout = NULL;
	GtkSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	gboolean is_on_left = FALSE;
	GtkHeaderBar* _tmp6_;
	GtkHeaderBar* _tmp7_;
#line 118 "../src/widgets/SideWindow.vala"
	g_return_if_fail (self != NULL);
#line 120 "../src/widgets/SideWindow.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 120 "../src/widgets/SideWindow.vala"
	g_object_get (_tmp0_, "gtk-decoration-layout", &_tmp1_, NULL);
#line 120 "../src/widgets/SideWindow.vala"
	_tmp2_ = _tmp1_;
#line 120 "../src/widgets/SideWindow.vala"
	layout = _tmp2_;
#line 121 "../src/widgets/SideWindow.vala"
	_tmp4_ = layout;
#line 121 "../src/widgets/SideWindow.vala"
	if (string_contains (_tmp4_, ":appmenu")) {
#line 121 "../src/widgets/SideWindow.vala"
		_tmp3_ = TRUE;
#line 335 "SideWindow.c"
	} else {
		const gchar* _tmp5_;
#line 121 "../src/widgets/SideWindow.vala"
		_tmp5_ = layout;
#line 121 "../src/widgets/SideWindow.vala"
		_tmp3_ = g_str_has_suffix (_tmp5_, ":");
#line 342 "SideWindow.c"
	}
#line 121 "../src/widgets/SideWindow.vala"
	is_on_left = _tmp3_;
#line 123 "../src/widgets/SideWindow.vala"
	_tmp6_ = self->side_headerbar;
#line 123 "../src/widgets/SideWindow.vala"
	gtk_header_bar_set_show_close_button (_tmp6_, is_on_left);
#line 124 "../src/widgets/SideWindow.vala"
	_tmp7_ = self->headerbar;
#line 124 "../src/widgets/SideWindow.vala"
	gtk_header_bar_set_show_close_button (_tmp7_, !is_on_left);
#line 118 "../src/widgets/SideWindow.vala"
	_g_free0 (layout);
#line 356 "SideWindow.c"
}

gboolean
marble_side_window_get_dark_mode (MarbleSideWindow* self)
{
	gboolean result;
#line 28 "../src/widgets/SideWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 28 "../src/widgets/SideWindow.vala"
	result = self->priv->_dark_mode;
#line 28 "../src/widgets/SideWindow.vala"
	return result;
#line 369 "SideWindow.c"
}

void
marble_side_window_set_dark_mode (MarbleSideWindow* self,
                                  gboolean value)
{
	gboolean old_value;
#line 28 "../src/widgets/SideWindow.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/widgets/SideWindow.vala"
	old_value = marble_side_window_get_dark_mode (self);
#line 28 "../src/widgets/SideWindow.vala"
	if (old_value != value) {
#line 28 "../src/widgets/SideWindow.vala"
		self->priv->_dark_mode = value;
#line 28 "../src/widgets/SideWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, marble_side_window_properties[MARBLE_SIDE_WINDOW_DARK_MODE_PROPERTY]);
#line 387 "SideWindow.c"
	}
}

gboolean
marble_side_window_get_show_window_controls (MarbleSideWindow* self)
{
	gboolean result;
#line 29 "../src/widgets/SideWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 29 "../src/widgets/SideWindow.vala"
	result = self->priv->_show_window_controls;
#line 29 "../src/widgets/SideWindow.vala"
	return result;
#line 401 "SideWindow.c"
}

void
marble_side_window_set_show_window_controls (MarbleSideWindow* self,
                                             gboolean value)
{
	gboolean old_value;
#line 29 "../src/widgets/SideWindow.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/widgets/SideWindow.vala"
	old_value = marble_side_window_get_show_window_controls (self);
#line 29 "../src/widgets/SideWindow.vala"
	if (old_value != value) {
#line 29 "../src/widgets/SideWindow.vala"
		self->priv->_show_window_controls = value;
#line 29 "../src/widgets/SideWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, marble_side_window_properties[MARBLE_SIDE_WINDOW_SHOW_WINDOW_CONTROLS_PROPERTY]);
#line 419 "SideWindow.c"
	}
}

const gchar*
marble_side_window_get_title (MarbleSideWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 30 "../src/widgets/SideWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/widgets/SideWindow.vala"
	_tmp0_ = self->priv->_title;
#line 30 "../src/widgets/SideWindow.vala"
	result = _tmp0_;
#line 30 "../src/widgets/SideWindow.vala"
	return result;
#line 436 "SideWindow.c"
}

void
marble_side_window_set_title (MarbleSideWindow* self,
                              const gchar* value)
{
	gchar* old_value;
#line 30 "../src/widgets/SideWindow.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/widgets/SideWindow.vala"
	old_value = marble_side_window_get_title (self);
#line 30 "../src/widgets/SideWindow.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 450 "SideWindow.c"
		gchar* _tmp0_;
#line 30 "../src/widgets/SideWindow.vala"
		_tmp0_ = g_strdup (value);
#line 30 "../src/widgets/SideWindow.vala"
		_g_free0 (self->priv->_title);
#line 30 "../src/widgets/SideWindow.vala"
		self->priv->_title = _tmp0_;
#line 30 "../src/widgets/SideWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, marble_side_window_properties[MARBLE_SIDE_WINDOW_TITLE_PROPERTY]);
#line 460 "SideWindow.c"
	}
}

static GObject *
marble_side_window_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MarbleSideWindow * self;
	GtkHeaderBar* _tmp0_;
	GtkHeaderBar* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkHeaderBar* _tmp3_;
	GtkHeaderBar* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkBox* b = NULL;
	GtkBox* _tmp6_;
	GtkBox* _tmp7_;
	GtkHeaderBar* _tmp8_;
	GtkBox* _tmp9_;
	GtkHeaderBar* _tmp10_;
	GtkBox* _tmp11_;
	GtkBox* _tmp12_;
	GtkBox* _tmp13_;
	GtkBox* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkBox* _tmp16_;
	GtkBox* _tmp17_;
	GtkBox* _tmp18_;
	GtkBox* _tmp19_;
	GtkBox* _tmp20_;
	GtkBox* _tmp21_;
	GtkSizeGroup* _tmp22_;
	GtkSizeGroup* _tmp23_;
	GtkHeaderBar* _tmp24_;
	GtkSizeGroup* _tmp25_;
	GtkBox* _tmp26_;
	GtkBox* _tmp27_;
#line 34 "../src/widgets/SideWindow.vala"
	parent_class = G_OBJECT_CLASS (marble_side_window_parent_class);
#line 34 "../src/widgets/SideWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 34 "../src/widgets/SideWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MARBLE_TYPE_SIDE_WINDOW, MarbleSideWindow);
#line 36 "../src/widgets/SideWindow.vala"
	_tmp0_ = (GtkHeaderBar*) gtk_header_bar_new ();
#line 36 "../src/widgets/SideWindow.vala"
	g_object_ref_sink (_tmp0_);
#line 36 "../src/widgets/SideWindow.vala"
	_g_object_unref0 (self->headerbar);
#line 36 "../src/widgets/SideWindow.vala"
	self->headerbar = _tmp0_;
#line 37 "../src/widgets/SideWindow.vala"
	_tmp1_ = self->headerbar;
#line 37 "../src/widgets/SideWindow.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
#line 37 "../src/widgets/SideWindow.vala"
	gtk_style_context_add_class (_tmp2_, "main-headerbar");
#line 38 "../src/widgets/SideWindow.vala"
	_tmp3_ = (GtkHeaderBar*) gtk_header_bar_new ();
#line 38 "../src/widgets/SideWindow.vala"
	g_object_ref_sink (_tmp3_);
#line 38 "../src/widgets/SideWindow.vala"
	_g_object_unref0 (self->side_headerbar);
#line 38 "../src/widgets/SideWindow.vala"
	self->side_headerbar = _tmp3_;
#line 39 "../src/widgets/SideWindow.vala"
	_tmp4_ = self->side_headerbar;
#line 39 "../src/widgets/SideWindow.vala"
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
#line 39 "../src/widgets/SideWindow.vala"
	gtk_style_context_add_class (_tmp5_, "side-headerbar");
#line 41 "../src/widgets/SideWindow.vala"
	_tmp6_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 41 "../src/widgets/SideWindow.vala"
	g_object_ref_sink (_tmp6_);
#line 41 "../src/widgets/SideWindow.vala"
	b = _tmp6_;
#line 43 "../src/widgets/SideWindow.vala"
	_tmp7_ = b;
#line 43 "../src/widgets/SideWindow.vala"
	_tmp8_ = self->side_headerbar;
#line 43 "../src/widgets/SideWindow.vala"
	gtk_box_pack_start (_tmp7_, (GtkWidget*) _tmp8_, FALSE, TRUE, (guint) 0);
#line 44 "../src/widgets/SideWindow.vala"
	_tmp9_ = b;
#line 44 "../src/widgets/SideWindow.vala"
	_tmp10_ = self->headerbar;
#line 44 "../src/widgets/SideWindow.vala"
	gtk_box_pack_start (_tmp9_, (GtkWidget*) _tmp10_, TRUE, TRUE, (guint) 0);
#line 46 "../src/widgets/SideWindow.vala"
	_tmp11_ = b;
#line 46 "../src/widgets/SideWindow.vala"
	gtk_window_set_titlebar ((GtkWindow*) self, (GtkWidget*) _tmp11_);
#line 47 "../src/widgets/SideWindow.vala"
	_tmp12_ = b;
#line 47 "../src/widgets/SideWindow.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp12_);
#line 49 "../src/widgets/SideWindow.vala"
	_tmp13_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 49 "../src/widgets/SideWindow.vala"
	g_object_ref_sink (_tmp13_);
#line 49 "../src/widgets/SideWindow.vala"
	_g_object_unref0 (self->side_box);
#line 49 "../src/widgets/SideWindow.vala"
	self->side_box = _tmp13_;
#line 50 "../src/widgets/SideWindow.vala"
	_tmp14_ = self->side_box;
#line 50 "../src/widgets/SideWindow.vala"
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) _tmp14_);
#line 50 "../src/widgets/SideWindow.vala"
	gtk_style_context_add_class (_tmp15_, "side-box");
#line 51 "../src/widgets/SideWindow.vala"
	_tmp16_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 51 "../src/widgets/SideWindow.vala"
	g_object_ref_sink (_tmp16_);
#line 51 "../src/widgets/SideWindow.vala"
	_g_object_unref0 (self->content_box);
#line 51 "../src/widgets/SideWindow.vala"
	self->content_box = _tmp16_;
#line 53 "../src/widgets/SideWindow.vala"
	_tmp17_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 53 "../src/widgets/SideWindow.vala"
	g_object_ref_sink (_tmp17_);
#line 53 "../src/widgets/SideWindow.vala"
	_g_object_unref0 (b);
#line 53 "../src/widgets/SideWindow.vala"
	b = _tmp17_;
#line 54 "../src/widgets/SideWindow.vala"
	_tmp18_ = b;
#line 54 "../src/widgets/SideWindow.vala"
	_tmp19_ = self->side_box;
#line 54 "../src/widgets/SideWindow.vala"
	gtk_box_pack_start (_tmp18_, (GtkWidget*) _tmp19_, FALSE, TRUE, (guint) 0);
#line 55 "../src/widgets/SideWindow.vala"
	_tmp20_ = b;
#line 55 "../src/widgets/SideWindow.vala"
	_tmp21_ = self->content_box;
#line 55 "../src/widgets/SideWindow.vala"
	gtk_box_pack_start (_tmp20_, (GtkWidget*) _tmp21_, TRUE, TRUE, (guint) 0);
#line 57 "../src/widgets/SideWindow.vala"
	_tmp22_ = gtk_size_group_new (GTK_SIZE_GROUP_HORIZONTAL);
#line 57 "../src/widgets/SideWindow.vala"
	_g_object_unref0 (self->priv->size_group);
#line 57 "../src/widgets/SideWindow.vala"
	self->priv->size_group = _tmp22_;
#line 58 "../src/widgets/SideWindow.vala"
	_tmp23_ = self->priv->size_group;
#line 58 "../src/widgets/SideWindow.vala"
	_tmp24_ = self->side_headerbar;
#line 58 "../src/widgets/SideWindow.vala"
	gtk_size_group_add_widget (_tmp23_, (GtkWidget*) _tmp24_);
#line 59 "../src/widgets/SideWindow.vala"
	_tmp25_ = self->priv->size_group;
#line 59 "../src/widgets/SideWindow.vala"
	_tmp26_ = self->side_box;
#line 59 "../src/widgets/SideWindow.vala"
	gtk_size_group_add_widget (_tmp25_, (GtkWidget*) _tmp26_);
#line 61 "../src/widgets/SideWindow.vala"
	_tmp27_ = b;
#line 61 "../src/widgets/SideWindow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp27_);
#line 62 "../src/widgets/SideWindow.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 34 "../src/widgets/SideWindow.vala"
	_g_object_unref0 (b);
#line 34 "../src/widgets/SideWindow.vala"
	return obj;
#line 631 "SideWindow.c"
}

static void
marble_side_window_class_init (MarbleSideWindowClass * klass,
                               gpointer klass_data)
{
#line 21 "../src/widgets/SideWindow.vala"
	marble_side_window_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/widgets/SideWindow.vala"
	g_type_class_adjust_private_offset (klass, &MarbleSideWindow_private_offset);
#line 21 "../src/widgets/SideWindow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_marble_side_window_get_property;
#line 21 "../src/widgets/SideWindow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_marble_side_window_set_property;
#line 21 "../src/widgets/SideWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = marble_side_window_constructor;
#line 21 "../src/widgets/SideWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = marble_side_window_finalize;
#line 21 "../src/widgets/SideWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MARBLE_SIDE_WINDOW_DARK_MODE_PROPERTY, marble_side_window_properties[MARBLE_SIDE_WINDOW_DARK_MODE_PROPERTY] = g_param_spec_boolean ("dark-mode", "dark-mode", "dark-mode", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/widgets/SideWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MARBLE_SIDE_WINDOW_SHOW_WINDOW_CONTROLS_PROPERTY, marble_side_window_properties[MARBLE_SIDE_WINDOW_SHOW_WINDOW_CONTROLS_PROPERTY] = g_param_spec_boolean ("show-window-controls", "show-window-controls", "show-window-controls", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/widgets/SideWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MARBLE_SIDE_WINDOW_TITLE_PROPERTY, marble_side_window_properties[MARBLE_SIDE_WINDOW_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 656 "SideWindow.c"
}

static void
marble_side_window_instance_init (MarbleSideWindow * self,
                                  gpointer klass)
{
#line 21 "../src/widgets/SideWindow.vala"
	self->priv = marble_side_window_get_instance_private (self);
#line 28 "../src/widgets/SideWindow.vala"
	self->priv->_dark_mode = TRUE;
#line 29 "../src/widgets/SideWindow.vala"
	self->priv->_show_window_controls = TRUE;
#line 669 "SideWindow.c"
}

static void
marble_side_window_finalize (GObject * obj)
{
	MarbleSideWindow * self;
#line 21 "../src/widgets/SideWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MARBLE_TYPE_SIDE_WINDOW, MarbleSideWindow);
#line 23 "../src/widgets/SideWindow.vala"
	_g_object_unref0 (self->headerbar);
#line 24 "../src/widgets/SideWindow.vala"
	_g_object_unref0 (self->side_headerbar);
#line 25 "../src/widgets/SideWindow.vala"
	_g_object_unref0 (self->side_box);
#line 26 "../src/widgets/SideWindow.vala"
	_g_object_unref0 (self->content_box);
#line 30 "../src/widgets/SideWindow.vala"
	_g_free0 (self->priv->_title);
#line 32 "../src/widgets/SideWindow.vala"
	_g_object_unref0 (self->priv->size_group);
#line 21 "../src/widgets/SideWindow.vala"
	G_OBJECT_CLASS (marble_side_window_parent_class)->finalize (obj);
#line 692 "SideWindow.c"
}

static GType
marble_side_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MarbleSideWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) marble_side_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MarbleSideWindow), 0, (GInstanceInitFunc) marble_side_window_instance_init, NULL };
	GType marble_side_window_type_id;
	marble_side_window_type_id = g_type_register_static (gtk_application_window_get_type (), "MarbleSideWindow", &g_define_type_info, 0);
	MarbleSideWindow_private_offset = g_type_add_instance_private (marble_side_window_type_id, sizeof (MarbleSideWindowPrivate));
	return marble_side_window_type_id;
}

GType
marble_side_window_get_type (void)
{
	static volatile gsize marble_side_window_type_id__once = 0;
	if (g_once_init_enter (&marble_side_window_type_id__once)) {
		GType marble_side_window_type_id;
		marble_side_window_type_id = marble_side_window_get_type_once ();
		g_once_init_leave (&marble_side_window_type_id__once, marble_side_window_type_id);
	}
	return marble_side_window_type_id__once;
}

static void
_vala_marble_side_window_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	MarbleSideWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MARBLE_TYPE_SIDE_WINDOW, MarbleSideWindow);
#line 21 "../src/widgets/SideWindow.vala"
	switch (property_id) {
#line 21 "../src/widgets/SideWindow.vala"
		case MARBLE_SIDE_WINDOW_DARK_MODE_PROPERTY:
#line 21 "../src/widgets/SideWindow.vala"
		g_value_set_boolean (value, marble_side_window_get_dark_mode (self));
#line 21 "../src/widgets/SideWindow.vala"
		break;
#line 21 "../src/widgets/SideWindow.vala"
		case MARBLE_SIDE_WINDOW_SHOW_WINDOW_CONTROLS_PROPERTY:
#line 21 "../src/widgets/SideWindow.vala"
		g_value_set_boolean (value, marble_side_window_get_show_window_controls (self));
#line 21 "../src/widgets/SideWindow.vala"
		break;
#line 21 "../src/widgets/SideWindow.vala"
		case MARBLE_SIDE_WINDOW_TITLE_PROPERTY:
#line 21 "../src/widgets/SideWindow.vala"
		g_value_set_string (value, marble_side_window_get_title (self));
#line 21 "../src/widgets/SideWindow.vala"
		break;
#line 745 "SideWindow.c"
		default:
#line 21 "../src/widgets/SideWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/widgets/SideWindow.vala"
		break;
#line 751 "SideWindow.c"
	}
}

static void
_vala_marble_side_window_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	MarbleSideWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MARBLE_TYPE_SIDE_WINDOW, MarbleSideWindow);
#line 21 "../src/widgets/SideWindow.vala"
	switch (property_id) {
#line 21 "../src/widgets/SideWindow.vala"
		case MARBLE_SIDE_WINDOW_DARK_MODE_PROPERTY:
#line 21 "../src/widgets/SideWindow.vala"
		marble_side_window_set_dark_mode (self, g_value_get_boolean (value));
#line 21 "../src/widgets/SideWindow.vala"
		break;
#line 21 "../src/widgets/SideWindow.vala"
		case MARBLE_SIDE_WINDOW_SHOW_WINDOW_CONTROLS_PROPERTY:
#line 21 "../src/widgets/SideWindow.vala"
		marble_side_window_set_show_window_controls (self, g_value_get_boolean (value));
#line 21 "../src/widgets/SideWindow.vala"
		break;
#line 21 "../src/widgets/SideWindow.vala"
		case MARBLE_SIDE_WINDOW_TITLE_PROPERTY:
#line 21 "../src/widgets/SideWindow.vala"
		marble_side_window_set_title (self, g_value_get_string (value));
#line 21 "../src/widgets/SideWindow.vala"
		break;
#line 783 "SideWindow.c"
		default:
#line 21 "../src/widgets/SideWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/widgets/SideWindow.vala"
		break;
#line 789 "SideWindow.c"
	}
}

